/* easter_data.c - generates input data for easter task */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main()
{
  int n, m, k, i, j, a, b, duplicate;
  int *ts, *as, *bs;
  time_t t;

  srand(time(&t));

  printf("n=");
  scanf("%d", &n);
  printf("m=");
  scanf("%d", &m);
  printf("k=");
  scanf("%d", &k);

  ts = (int *) malloc((n + 1) * sizeof(int));
  for (i = 1; i <= n; i++)
   ts[i] = 0;

  j = 1;
  for (i = 1; i < n; i++)
  {
    ts[j] = i;
    j = (j + rand()) % n + 1;
    while (ts[j]) j = (j % n) + 1;
  }
  ts[j] = n;

  as = (int *) malloc(m * sizeof(int));
  bs = (int *) malloc(m * sizeof(int));

  printf("%d %d %d\n", n, m, k);
  for (i = 0; i < m; i++)
  {
    if (10 * i / m > 10 * (i - 1) / m) fprintf(stderr, "%4d%%\r", 100 * i / m);
    do {
      a = 1 + rand() % (n - 1); 
      b = rand() % (n - a) + a + 1;
      duplicate = 0;
      for (j = 0; j < i; j++)
        if ((a == as[j]) && (b == bs[j])) { duplicate = 1; break; }
    } while (duplicate);
    as[i] = a; bs[i] = b;
       
    printf("%d %d %d\n", a, b, 1 + (int)((float)(rand() % 10) * 0.3 * (float)(b - a)));
  }
  
  as = (int *) realloc(as, k * sizeof(int));
  bs = (int *) realloc(bs, k * sizeof(int));

  for (i = 0; i < k; i++)
  {
    if (10 * i / k > 10 * (i - 1) / k) fprintf(stderr, "%4d%%\r", 100 * i / k);
    do {
      a = 1 + rand() % (n - 1);
      b = rand() % (n - a) + a + 1;
      duplicate = 0;
      for (j = 0; j < i; j++)
        if ((a == as[j]) && (b == bs[j])) { duplicate = 1; break; }
    } while (duplicate);
    as[i] = a; bs[i] = b;

    printf("%d %d %d\n", b, a, 1 + (int)((float)(rand() % 10) * 0.7 * (float)(b - a)));
  }

  free(as); free(bs); free(ts);
  return 0;
}

